import { Ref } from 'vue';
import { UseFloatingOptions, ReferenceElement, FloatingElement, MaybeElement, MaybeReadonlyRef } from '@floating-ui/vue';
import { SfPopoverPlacement, SfPopoverStrategy, SfPopoverBasePlacement } from '@storefront-ui/shared';

export { SfPopoverPlacement, SfPopoverStrategy, type SfPopoverBasePlacement };
export interface UsePopoverOptions<ReferenceEl extends ReferenceElement = ReferenceElement> {
    referenceRef?: Readonly<Ref<MaybeElement<ReferenceEl>>>;
    floatingRef?: Readonly<Ref<MaybeElement<FloatingElement>>>;
    isOpen?: UseFloatingOptions['open'];
    placement?: MaybeReadonlyRef<`${SfPopoverPlacement}` | undefined>;
    middleware?: UseFloatingOptions['middleware'];
    strategy?: MaybeReadonlyRef<`${SfPopoverStrategy}` | undefined>;
}
//# sourceMappingURL=types.d.ts.map