import { UseScrollableOptions } from '../../index.ts';
import { ComputedRef } from 'vue';

export declare function useScrollable<TElement extends HTMLElement>(options?: ComputedRef<Partial<UseScrollableOptions>>): {
    containerRef: import('vue').Ref<TElement | undefined, TElement | undefined>;
    getPrevButtonProps: ComputedRef<{
        onClick: () => void;
        disabled: boolean;
    }>;
    getNextButtonProps: ComputedRef<{
        onClick: () => void;
        disabled: boolean;
    }>;
    showNext: () => void;
    showPrev: () => void;
    state: import('vue').Ref<{
        hasPrev: boolean;
        hasNext: boolean;
        isDragged: boolean;
    }, {
        hasPrev: boolean;
        hasNext: boolean;
        isDragged: boolean;
    } | {
        hasPrev: boolean;
        hasNext: boolean;
        isDragged: boolean;
    }>;
};
//# sourceMappingURL=useScrollable.d.ts.map